Description

When a user is only having per entity grants to UPDATE TaxonNames adding a basionym to a taxonname may fail:

e TaxonName "Beta exemplaris" for which the user has the UPDATE authority
e TaxonName "Alpha exemplaris" for which the user is not having the update permission.

Adding "Alpha exemplaris" as basionym to "Beta exemplaris" will fail in this situation during the hibernate session flush since the new
basionym name relationships will be added to both of the taxon names. This operation should be possible, though. The scientific
name at the from-side (that is the basionym) of the name relation is not altered by using it as a basionym for another name.

The same issue exists also replaced synonym relations!
Possible solutions:

¢ General solution:
o Skip the permission check for name relations at the from-side for basionym and replaced-synonym relations. How about
other relations? (This can be reached e.g. by removing the according Cascade)
o Introduce a new permission concept like privileged access for updates: priviledged update? (see SAP)
¢ Application specific: Temporarily grant the UPDATE authority to the user performing the operations in the client application.
Grant before flushing the session and remove the grant afterwards. Use a try-catch-finally clause where the withdrawal of the
temporary permission is done in the finally clause. --> #7391

see also WorkshopRightsAndRoles2017-11

Related issues:

Related to EDIT - bug #7391: grant UPDATE for taxonnames temporarily when usi... Rejected
Related to EDIT - bug #7392: Remove Cascade from relations Closed
History

#1 - 04/30/2018 09:39 AM - Andreas Kohlbecker

- Related to bug #7391: grant UPDATE for taxonnames temporarily when using a name as basionym added

#2 - 04/30/2018 09:40 AM - Andreas Kohlbecker

- Tags changed from phycobank to permission

#3 - 04/30/2018 09:40 AM - Andreas Kohlbecker

- Description updated

#4 - 04/30/2018 10:09 AM - Andreas Miiller
- Status changed from New to In Progress

- Target version changed from Unassigned CDM tickets to Release 5.0

I think we should first check if removing Cascade from RelationBase.from and RelationBase.to may solve the problem. This is something we are
planning anyway to improve performance.

Only we need to check if some explicit saves need to be handled within running applications (TaxEditor, VaadinEditor, imports, ...). First expectation
is that only imports may need to be adapted at some points.

#5 - 04/30/2018 10:11 AM - Andreas Miiller
- Description updated

Andreas Milller wrote:
I think we should first check if removing Cascade from RelationBase.from and RelationBase.to may solve the problem. This is something we are

planning anyway to improve performance.

This actually is equivalent with the "general solution"

#6 - 04/30/2018 10:25 AM - Andreas Kohlbecker
- Description updated

#7 - 04/30/2018 10:28 AM - Andreas Kohlbecker
- Description updated

#8 - 04/30/2018 12:08 PM - Andreas Kohlbecker

| did some further examination of an concrete example for this issue. The problem actually only occurs when adding a second basionym to a name B
which already is having a basionym A where the basionym A is already being used as basionym for a name C. In this case the
PermissionDeniedException is thrown when the second basionym has been added to A.

#9 - 04/30/2018 02:07 PM - Andreas Miiller

- Related to bug #7392: Remove Cascade from relations added

#10 - 05/02/2018 09:12 AM - Andreas Kohlbecker

- Status changed from In Progress to Duplicate

This issue has been clearly solved by fixing #7392, so we can consider this issue being a duplicate of #7392.
